import System;
import System.Diagnostics;
import System.ComponentModel;
import System.Windows.Forms;

// declare an instance of the Scriptlet type, and create a new instance all at once
var scriptlet : Scriptlet = new Scriptlet;

// call the main method to get things running inside the class, 
// i just don't like top-down sequential execution
// outside of classes, it just seems archaic to me
scriptlet.Main();

/// <Summary>
/// The Scriptlet class contains methods to redirect script flow from sequential into a class controlled flow
/// </Summary>
public class Scriptlet // extends Scriptlet
{		
	/// <Summary>
	/// Initializes a new instance of the Scriptlet class
	/// </Summary>
	function Scriptlet()
	{
	
	}

	/// <Summary>
	/// The main method that channels script flow into the class
	/// </Summary>				
    function Main() : void
    {     
		Debug.WriteLine("This information is being written to the Debug output from a script!!!");
		Debug.WriteLine(_scriptingHost.VsaEngine.RootMoniker);        
		
		// change the title of the window
		_scriptableForm.Text = "Scriptable Window";
		
		// add a menu item
		_scriptableForm.FileMenu.MenuItems[0].MenuItems.Add("Scripted Menu Item");
		
		// wire up to some events on the form
		_scriptableForm.add_Closing(this.ScriptableForm_Closing);		
    }
        
	/// <Summary>
	/// Intercepts the closing event from the form
	/// </Summary>
    function ScriptableForm_Closing(sender : Object, e : CancelEventArgs) : void
	{
		// prompts the user and confirms 
		if (MessageBox.Show("Are you sure you want to exit?", "Exit Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
			e.Cancel = true;			
	}	
}

